#include <tchar.h>


//zNX
template <class TYPE> class PWCArray
{
protected://///////////////////////////////////////////////////
	TYPE * Data;
	intptr_t Length, ArrangementSize;
	void ReAlloc(const intptr_t & size)
	{
		TYPE * p;
		intptr_t i, j;
		if(size <= ArrangementSize) return;
		for(j = 1; size > j; j <<= 1){}
		p = new TYPE[j];
		for(i = 0; i < Length; i++) p[i] = Data[i];
		delete [] Data;
		Data = p;
		ArrangementSize = j;
	}
	template<class T> PWCArray & Load(T & x)
	{
		Clear();
		*this += x;
		return *this;
	}
	template<class T> PWCArray & AddTP(T & x)
	{
		intptr_t i;
		for(i = 0; x[i] != 0; i++){}
		AddTail(x, i);
		return *this;
	}
public:////////////////////////////////////////////////////////
	PWCArray(const intptr_t Size = 0)
	{
		Length = 0;
		ArrangementSize = (Size >= 0) ? Size : 0;
		Data = new TYPE[ArrangementSize];
	}
	~PWCArray()
	{
		delete [] Data;
	}
	void AddTail(const TYPE * const st, const intptr_t len)
	{
		intptr_t i;
		ReAlloc(Length+len);
		for(i = 0; i < len; i++) Data[Length+i] = st[i];
		Length += len;
	}
	void Delete()
	{
		Length = 0;
		delete [] Data;
		Data = new TYPE[0];
		ArrangementSize = 0;
	}
	void Clear()
	{
		Length = 0;
	}
	TYPE * GetData()
	{
		return Data;
	}
	const TYPE * GetConst() const
	{
		return Data;
	}
	intptr_t GetLength() const
	{
		return Length;
	}
	intptr_t SetLength(const intptr_t l)
	{
		ReAlloc(l);
		Length = l;
		return Length;
	}
	///////////////////////////
	TYPE & Pop()
	{
		return Data[--Length];
	}
	TYPE & Tail()
	{
		return Data[Length-1];
	}
	const TYPE & GetTail() const
	{
		return Data[Length-1];
	}
	TYPE & operator[] (const intptr_t i)
	{
		if(i >= Length){
			ReAlloc(i+1);
			Length = i+1;
		}
		return Data[i];
	}
	bool operator == (const PWCArray & x) const
	{
		intptr_t i;
		if(Length != x.Length) return false;
		for(i = 0; i < Length; i++){
			if(Data[i] != x.Data[i]) return false;
		}
		return true;
	}
	bool operator != (const PWCArray & x) const
	{
		return !(*this == x);
	}
	///////////////////////////
	PWCArray & operator = (const PWCArray & x)
	{
		return Load(x);
	}
	PWCArray & operator = (const TYPE * const & x)
	{
		return Load(x);
	}
	PWCArray & operator = (const TYPE & x)
	{
		return Load(x);
	}
	///////////////////////////
	PWCArray & operator += (const PWCArray & x)
	{
		AddTail(x.Data, x.Length);
		return *this;
	}
	PWCArray & operator += (const TYPE * const & x)
	{
		return AddTP(x);
	}
	PWCArray & operator += (const TYPE & x)
	{
		(*this)[Length] = x;
		return *this;
	}
};

template <class TYPE> class PWCArrayQuad : public PWCArray<TYPE>
{
protected://///////////////////////////////////////////////////
	void ReAlloc(const intptr_t & size)
	{
		TYPE * p;
		intptr_t i, j;
		if(size <= ArrangementSize) return;
		for(j = 1; size > j; j <<= 1){}
		p = new TYPE[j];
		for(i = 0; i < Length; i++){
			((PWCArrayQuad *)p)[i].Data = ((PWCArrayQuad *)Data)[i].Data;
			((PWCArrayQuad *)p)[i].Length = ((PWCArrayQuad *)Data)[i].Length;
			((PWCArrayQuad *)p)[i].ArrangementSize = ((PWCArrayQuad *)Data)[i].ArrangementSize;
			((PWCArrayQuad *)Data)[i].Data = 0;
		}
		delete [] Data;
		Data = p;
		ArrangementSize = j;
	}
public:////////////////////////////////////////////////////////
	void AddTail(const TYPE * const st, const intptr_t len)
	{
		intptr_t i;
		ReAlloc(Length+len);
		for(i = 0; i < len; i++) Data[Length+i] = st[i];
		Length += len;
	}
	void AddTail(TYPE * const st, const intptr_t len)
	{
		intptr_t i;
		ReAlloc(Length+len);
		for(i = 0; i < len; i++) Data[Length+i] = st[i];
		Length += len;
	}
	intptr_t SetLength(const intptr_t l)
	{
		ReAlloc(l);
		Length = l;
		return Length;
	}
	///////////////////////////
	TYPE & operator[] (const intptr_t i)
	{
		if(i >= Length){
			ReAlloc(i+1);
			Length = i+1;
		}
		return Data[i];
	}
};

//X^bNNX
template <class T> class PWCStack
{
protected://///////////////////////////////////////////////////
	template <class Type> struct PWCStackItem
	{
		Type * Item;
		PWCStackItem * PreItem;
		intptr_t Size;
		PWCStackItem(const intptr_t & s)
		{
			Size = s;
			Item = new Type[Size];
		}
		~PWCStackItem()
		{
			delete [Size] Item;
		}
	};
	PWCStackItem<T> * item;
	intptr_t ArrIndex, PWCStackArrangementSize;
	template<class Tp> T & TPush(Tp & it)
	{
		PWCStackItem<T> * tmp;
		item->Item[ArrIndex++] = it;
		if(ArrIndex < PWCStackArrangementSize) return item->Item[ArrIndex-1];
		tmp = item;
		item = new PWCStackItem<T>(PWCStackArrangementSize);
		item->PreItem = tmp;
		ArrIndex = 0;
		return tmp->Item[PWCStackArrangementSize-1];
	}
public:////////////////////////////////////////////////////////
	PWCStack(const intptr_t Size = 16)
	{
		ArrIndex = 0;
		PWCStackArrangementSize = (Size > 0) ? Size : 1;
		item = new PWCStackItem<T>(PWCStackArrangementSize);
		item->PreItem = item;
	}
	~PWCStack()
	{
		Clear();
		delete item;
	}
	T & Push(const T & it)
	{
		return TPush(it);
	}
	T & Push(T & it)
	{
		return TPush(it);
	}
	T & Pop()
	{
		PWCStackItem<T> * tmp;
		if(ArrIndex > 0) return item->Item[--ArrIndex];
		if(item->PreItem == item) return item->Item[0];
		tmp = item;
		item = item->PreItem;
		delete tmp;
		ArrIndex = PWCStackArrangementSize-1;
		return item->Item[ArrIndex];
	}
	const T & Check() const
	{
		if(ArrIndex > 0) return item->Item[ArrIndex-1];
		if(item->PreItem == item) return item->Item[0];
		return item->PreItem->Item[PWCStackArrangementSize-1];
	}
	void Clear()
	{
		while(!IsEmpty()) Pop();
	}
	bool IsEmpty() const
	{
		return ArrIndex <= 0 && item->PreItem == item;
	}
};

template <class T> class PWCReverseStack : public PWCStack<T>
{
protected://///////////////////////////////////////////////////
	PWCStackItem<T> * tailitem;
	intptr_t TailIndex;
	template<class Tp> T & TPush(Tp & it)
	{
		PWCStackItem<T> * tmp;
		tailitem->Item[TailIndex++] = it;
		if(TailIndex < PWCStackArrangementSize) return tailitem->Item[TailIndex-1];
		tmp = tailitem;
		tailitem = new PWCStackItem<T>(PWCStackArrangementSize);
		tmp->PreItem = tailitem;
		TailIndex = 0;
		return tmp->Item[PWCStackArrangementSize-1];
	}
public:////////////////////////////////////////////////////////
	PWCReverseStack(const intptr_t Size = 16) : PWCStack<T>(Size)
	{
		tailitem = item;
		TailIndex = 0;
	}
	~PWCReverseStack()
	{
		Clear();
		ArrIndex = 0;
		item->PreItem = item;
	}
	T & Push(const T & it)
	{
		return TPush(it);
	}
	T & Push(T & it)
	{
		return TPush(it);
	}
	T & Pop()
	{
		PWCStackItem<T> * tmp;
		if(ArrIndex < TailIndex) return item->Item[ArrIndex++];
		if(item == tailitem) return item->Item[TailIndex];
		if(ArrIndex < PWCStackArrangementSize) return item->Item[ArrIndex++];
		tmp = item;
		item = item->PreItem;
		delete tmp;
		ArrIndex = 1;
		return item->Item[0];
	}
	const T & Check() const
	{
		if(ArrIndex < TailIndex) return item->Item[ArrIndex];
		if(item == tailitem) return item->Item[TailIndex];
		if(ArrIndex < PWCStackArrangementSize) return item->Item[ArrIndex];
		return item->PreItem->Item[0];
	}
	void Clear()
	{
		while(!IsEmpty()) Pop();
	}
	bool IsEmpty() const
	{
		return ArrIndex >= TailIndex && item == tailitem;
	}
};

//ChJ[hGW
class PowerWildCard
{
protected://///////////////////////////////////////////////////
	typedef const _TCHAR * STRING;

	struct AndModeInfo
	{
		bool Mode;
		STRING StrStart, StrEnd;
		AndModeInfo & operator = (const AndModeInfo & x)
		{
			Mode = x.Mode;
			StrStart = x.StrStart;
			StrEnd = x.StrEnd;
			return *this;
		}
	};
	struct RepeatModeInfo
	{
		bool Mode;
		STRING PtnStart;
		intptr_t Count, CountLow, CountHigh;
		RepeatModeInfo & operator = (const RepeatModeInfo & x)
		{
			Mode = x.Mode;
			PtnStart = x.PtnStart;
			Count = x.Count;
			CountLow = x.CountLow;
			CountHigh = x.CountHigh;
			return *this;
		}
	};

	//ubN
	struct BlockInfo
	{
		AndModeInfo And;
		RepeatModeInfo Repeat;
		BlockInfo & operator = (const BlockInfo & x)
		{
			And = x.And;
			Repeat = x.Repeat;
			return *this;
		}
	};

	struct PtnStrIdx
	{
		STRING pi, si;
		PtnStrIdx & operator = (const PtnStrIdx & x)
		{
			pi = x.pi;
			si = x.si;
			return *this;
		}
	};
	STRING PtnTop, StrEnd;
	BlockInfo NowBlock;
	PWCStack<BlockInfo> BlockStk;
	PWCStack<BlockInfo> CloseStk;
	PWCStack<PtnStrIdx> IdxStk;
	PWCArray<int> RepeatCountArr;
	PWCArray<STRING> CloseMapArr;
	PWCArray<STRING> DivMapArr;

	//ʂíjƂ߂
	STRING ParenthesisClosePoint(const STRING & Ptn, const _TCHAR & Open, const _TCHAR & Close)
	{
		intptr_t i;
		if(CloseMapArr.GetData()[Ptn-PtnTop] != 0) return CloseMapArr.GetData()[Ptn-PtnTop];
		for(i = 0; Ptn[i] != _T('\0'); i++){
			if(Ptn[i] == Close) return CloseMapArr.GetData()[Ptn-PtnTop] = Ptn+i+1;
			switch(Open){
			default:
			case _T('('):
				if(Ptn[i] == _T('(')){
					i = ParenthesisClosePoint(Ptn+i+1, _T('('), _T(')'))-Ptn-1;
					continue;
				}
				if(Ptn[i] == _T('"')){
					i = ParenthesisClosePoint(Ptn+i+1, _T('"'), _T('"'))-Ptn-1;
					continue;
				}
			case _T('"'):
				if(Ptn[i] == _T('\'')){
					i = ParenthesisClosePoint(Ptn+i+1, _T('\''), _T('\''))-Ptn-1;
					continue;
				}
			case _T('\''):
				break;
			}
			if((Ptn[i]==_T('$')) && (Ptn[i+1]!=_T('\0'))) i++;
		}
		return CloseMapArr.GetData()[Ptn-PtnTop] = Ptn+i;
	}

	//̋؂Ĺíjꏊ߂
	STRING NextDivisionBar(const STRING & Ptn, const _TCHAR & Division, const _TCHAR & Open, const _TCHAR & Close)
	{
		intptr_t i;
		if(DivMapArr.GetData()[Ptn-PtnTop] != 0) return DivMapArr.GetData()[Ptn-PtnTop];
		for(i = 0; (Ptn[i]!=Close) && (Ptn[i]!=_T('\0')); i++){
			if(Ptn[i] == Division) return DivMapArr.GetData()[Ptn-PtnTop] = Ptn+i+1;
			switch(Open){
			default:
			case _T('('):
				if(Ptn[i] == _T('(')){
					i = ParenthesisClosePoint(Ptn+i+1, _T('('), _T(')'))-Ptn-1;
					continue;
				}
				if(Ptn[i] == _T('"')){
					i = ParenthesisClosePoint(Ptn+i+1, _T('"'), _T('"'))-Ptn-1;
					continue;
				}
			case _T('"'):
				if(Ptn[i] == _T('\'')){
					i = ParenthesisClosePoint(Ptn+i+1, _T('\''), _T('\''))-Ptn-1;
					continue;
				}
			case _T('\''):
				break;
			}
			if((Ptn[i]==_T('$')) && (Ptn[i+1]!=_T('\0'))) i++;
		}
		return DivMapArr.GetData()[Ptn-PtnTop] = Ptn;
	}

	intptr_t ReadCount(const STRING & Ptn, const STRING & Str, intptr_t & l)
	{
		intptr_t n, j;
		n = ReadCountSub(Ptn, Str, j);
		l = j;
		while((Ptn[l] == _T('+')) || (Ptn[l] == _T('-'))){
			switch(Ptn[l]){
			case _T('+'):
				n += ReadCountSub(Ptn+(++l), Str, j);
				l += j;
				break;
			case _T('-'):
				n -= ReadCountSub(Ptn+(++l), Str, j);
				l += j;
				break;
			}
		}
		return n;
	}
	void RepeatCountUp()
	{
		PtnStrIdx tmp;
		NowBlock.Repeat.Count++;
		tmp.pi = (STRING)0;
		tmp.si = (STRING)4;
		IdxStk.Push(tmp);
	}
	void AddRepeatCountArr(PtnStrIdx & ind, PtnStrIdx & end, const intptr_t & i)
	{
		if(ind.pi[0] != _T('@')) return;
		ind.pi++;
		RepeatCountArr += i;
		end.pi = (STRING)0;
		end.si = (STRING)3;
		IdxStk.Push(end);
	}
	void WildNormalMain(PtnStrIdx & ind)
	{
		PtnStrIdx tmp;
		NowBlock.And.StrStart = ind.si;
		NowBlock.And.Mode = false;
		NowBlock.Repeat.Count = 0;
		IdxStk.Push(ind);
		tmp.pi = (STRING)0;
		tmp.si = (STRING)0;
		IdxStk.Push(tmp);
	}
	void WildRepeat(PtnStrIdx & ind, PtnStrIdx & end, const intptr_t & min, const intptr_t & max)
	{
		NowBlock.Repeat.Mode = true;
		NowBlock.Repeat.CountLow = min;
		NowBlock.Repeat.CountHigh = max;
		if(NowBlock.Repeat.CountHigh <= 0){
			ind.pi = ParenthesisClosePoint(ind.pi, _T('('), _T(')'));
			WildBlockOpenRet();
			AddRepeatCountArr(ind, end, 0);
			return;
		}
		NowBlock.Repeat.PtnStart = ind.pi;
		WildNormalMain(ind);
		if(NowBlock.Repeat.CountLow <= 0){
			if((end.pi = ParenthesisClosePoint(ind.pi, _T('('), _T(')')))[0] != _T('~')){
				IdxStk.Push(ind);
				ind.pi = end.pi;
				end.pi = (STRING)0;
				end.si = (STRING)5;
				IdxStk.Push(end);
				AddRepeatCountArr(ind, end, 0);
				WildBlockClose();
				return;
			}
			end.pi++;
			end.si = ind.si;
			IdxStk.Push(end);
			end.pi = (STRING)0;
			end.si = (STRING)6;
			IdxStk.Push(end);
			return;
		}
	}
	void WildRepeatAgain(PtnStrIdx & ind, PtnStrIdx & end)
	{
		end.pi = (STRING)NowBlock.And.Mode;
		end.si = NowBlock.And.StrStart;
		IdxStk.Push(end);
		ind.pi = NowBlock.Repeat.PtnStart;
		IdxStk.Push(ind);
		end.pi = (STRING)0;
		end.si = (STRING)7;
		IdxStk.Push(end);
		NowBlock.And.Mode = false;
		NowBlock.And.StrStart = ind.si;
	}
	bool WildNegation(PtnStrIdx & ind, PtnStrIdx & end)
	{
		if(NegationMatch(ind, end)){
			if(ind.pi[-2] == _T('*')) return false;
			IdxStk.Push(ind);
			IdxStk.Push(end);
			end.pi = (STRING)0;
			end.si = (STRING)11;
			IdxStk.Push(end);
			return false;
		}
		IdxStk.Push(ind);
		IdxStk.Push(end);
		end.pi = (STRING)0;
		end.si = (STRING)11;
		IdxStk.Push(end);
		return true;
	}
	void WildNormal(PtnStrIdx & ind)
	{
		NowBlock.Repeat.Mode = false;
		WildNormalMain(ind);
	}
	void WildBlockOpen(PtnStrIdx & ind, PtnStrIdx & end)
	{
		intptr_t m, n, i;
		m = ReadCount(ind.pi, ind.si, i);
		if(ind.pi[i] == _T('~')){
			ind.pi += i+1;
			n = ReadCount(ind.pi, ind.si, i);
			ind.pi += i;
			if(i == 0) n = INT_MAX;
			BlockStk.Push(NowBlock);
			if(m <= n) WildRepeat(ind, end, m, n);
			else WildRepeat(ind, end, n, m);
		}else if(i > 0){
			ind.pi += i;
			BlockStk.Push(NowBlock);
			WildRepeat(ind, end, m, m);
		}else{
			BlockStk.Push(NowBlock);
			WildNormal(ind);
		}
	}
	void WildBlockOpenRet()
	{
		NowBlock = BlockStk.Pop();
	}
	void WildBlockClose()
	{
		PtnStrIdx tmp;
		CloseStk.Push(NowBlock);
		NowBlock = BlockStk.Pop();
		tmp.pi = (STRING)0;
		tmp.si = (STRING)1;
		IdxStk.Push(tmp);
	}
	void WildBlockCloseRet()
	{
		BlockStk.Push(NowBlock);
		NowBlock = CloseStk.Pop();
	}
	bool WildClass(PtnStrIdx & ind)
	{
		if(ind.pi[0] == _T('!')){
			ind.pi++;
			if(ClassMatch(ind.pi, ind.si[0])) return false;
			ind.pi = ParenthesisClosePoint(ind.pi, _T('\''), _T('\''));
			ind.si++;
			return true;
		}
		if(ClassMatch(ind.pi, ind.si[0])){
			ind.pi = ParenthesisClosePoint(ind.pi, _T('\''), _T('\''));
			ind.si++;
			return true;
		}
		return false;
	}
	bool WildFuzzy(PtnStrIdx & ind, PtnStrIdx & end){
		intptr_t Point, Limit, pro;
		STRING tmp;
		Limit = ReadCount(ind.pi, ind.si, pro);
		ind.pi += pro;
		if(Limit == 0) return ExactlyMatch(ind);
		Point = pro = 0;
		end.pi = (STRING)0;
		end.si = (STRING)99;
		IdxStk.Push(end);
		return FuzzyMatch(ind, end, Point, Limit, tmp, pro);
	}
	bool ExactlyMatch(PtnStrIdx & ind)
	{
		intptr_t i;
		for(; ind.pi[0] != _T('"'); ind.si++){
			if(!StrCheck(ind.si)) return false;
			switch(ind.pi[0]){
			case _T('\''):
				if((++ind.pi)[0] != _T('!')){
					if(!ClassMatch(ind.pi, ind.si[0])) return false;
				}else{
					ind.pi++;
					if(ClassMatch(ind.pi, ind.si[0])) return false;
				}
				ind.pi = ParenthesisClosePoint(ind.pi, _T('\''), _T('\''));
				break;
			case _T('$'):
				if((++ind.pi)[0] == _T('#')){
					if((_TUCHAR)ind.si[0] != ReadCount(ind.pi+1, ind.si, i)) return false;
					ind.pi += i+1;
					break;
				}
			default:
				if((ind.pi++)[0] != ind.si[0]) return false;
			}
		}
		ind.pi++;
		return true;
	}
	bool FuzzyMatch(PtnStrIdx & ind, PtnStrIdx & end, intptr_t & Point, const intptr_t & Limit, STRING & tmp, intptr_t & pro)
	{
		intptr_t i;
		bool ret;
		while(true){
			if((Point > Limit) || ((pro != 0) && !StrCheck(ind.si))){
				do{
					if(!FuzzyRet1(ind, end, tmp, pro, Point)) return false;
				}while((Point > Limit) || !StrCheck(ind.si));
			}
			switch(pro){
			case 0:
				if(ind.pi[0] == _T('"')){
					ind.pi++;
					return true;
				}
				tmp = ind.pi;
				if(!StrCheck(ind.si)) ret = false;
				else switch(tmp[0]){
				case _T('\''):
					if((++tmp)[0] != _T('!')){
						ret = ClassMatch(tmp, ind.si[0]);
					}else{
						tmp++;
						ret = !ClassMatch(tmp, ind.si[0]);
					}
					tmp = ParenthesisClosePoint(tmp, _T('\''), _T('\''));
					break;
				case _T('$'):
					if((++tmp)[0] == _T('#')){
						ret = ((_TUCHAR)ind.si[0] == ReadCount(tmp+1, ind.si, i));
						tmp += i+1;
						break;
					}
				default:
					ret = ((tmp++)[0] == ind.si[0]);
				}
				IdxStk.Push(ind);
				end.pi = tmp;
				if(ret) end.si = (STRING)1;
				else end.si = (STRING)2;
				IdxStk.Push(end);
				end.pi = (STRING)Point;
				end.si = (STRING)Limit;
				IdxStk.Push(end);
				end.pi = (STRING)0;
				end.si = (STRING)10;
				IdxStk.Push(end);
				ind.pi = tmp;
				Point++;
				pro = 0;
				break;
			case 1:
				IdxStk.Push(ind);
				end.pi = tmp;
				end.si = (STRING)3;
				IdxStk.Push(end);
				end.pi = (STRING)Point;
				end.si = (STRING)Limit;
				IdxStk.Push(end);
				end.pi = (STRING)0;
				end.si = (STRING)10;
				IdxStk.Push(end);
				ind.pi = tmp;
				ind.si++;
				pro = 0;
				break;
			case 2:
				IdxStk.Push(ind);
				end.pi = tmp;
				end.si = (STRING)3;
				IdxStk.Push(end);
				end.pi = (STRING)Point;
				end.si = (STRING)Limit;
				IdxStk.Push(end);
				end.pi = (STRING)0;
				end.si = (STRING)10;
				IdxStk.Push(end);
				ind.pi = tmp;
				ind.si++;
				Point++;
				pro = 0;
				break;
			case 3:
				ind.si++;
				Point++;
				pro = 0;
				break;
			}
		}
	}
	bool FuzzyRet1(PtnStrIdx & ind, PtnStrIdx & end, STRING & tmp, intptr_t & pro, intptr_t & Point)
	{
		end = IdxStk.Pop();
		if((intptr_t)end.si != 10) return false;
		end = IdxStk.Pop();
		Point = (intptr_t)end.pi;
		end = IdxStk.Pop();
		tmp = end.pi;
		pro = (intptr_t)end.si;
		ind = IdxStk.Pop();
		return true;
	}
	bool FuzzyRet2(PtnStrIdx & ind, PtnStrIdx & end)
	{
		intptr_t Point, Limit, pro;
		STRING tmp;
		end = IdxStk.Pop();
		Point = (intptr_t)end.pi;
		Limit = (intptr_t)end.si;
		end = IdxStk.Pop();
		tmp = end.pi;
		pro = (intptr_t)end.si;
		ind = IdxStk.Pop();
		if(FuzzyMatch(ind, end, Point, Limit, tmp, pro)) return true;
		return false;
	}
	bool ClassMatch(STRING & Ptn, const _TCHAR & Cha)
	{
		intptr_t j, c1, c2;
		c1 = 0;
		for(; Ptn[0] != _T('\''); Ptn++){
			switch(Ptn[0]){
			case _T('~'):
				switch((++Ptn)[0]){
				case _T('\''):
					Ptn--;
					c2 = INT_MAX;
					break;
				case _T('$'):
					if((++Ptn)[0] == _T('#')){
						if((_TUCHAR)Cha == (c2=ReadCount(Ptn+1, &Cha, j))) return true;
						Ptn += j;
						break;
					}
				default:
					if(Ptn[0] == Cha) return true;
					c2 = (_TUCHAR)Ptn[0];
				}
				if((c1<(_TUCHAR)Cha) && ((_TUCHAR)Cha<c2) || (c2<(_TUCHAR)Cha) && ((_TUCHAR)Cha<c1)) return true;
				c1 = c2;
				break;
			case _T('$'):
				if((++Ptn)[0] == _T('#')){
					if((_TUCHAR)Cha == (c1=ReadCount(Ptn+1, &Cha, j))) return true;
					Ptn += j;
					break;
				}
			default:
				if(Ptn[0] == Cha) return true;
				c1 = (_TUCHAR)Ptn[0];
			}
		}
		return false;
	}
	bool CaseZero(const STRING & Str)
	{
		return (!NowBlock.And.Mode || (Str == NowBlock.And.StrEnd)) && CaseZeroMain(Str);
	}
	bool CaseAnd(PtnStrIdx & ind, PtnStrIdx & end)
	{
		if(NowBlock.And.Mode){
			if(ind.si != NowBlock.And.StrEnd) return false;
			ind.si = NowBlock.And.StrStart;
			return true;
		}
		NowBlock.And.StrEnd = ind.si;
		NowBlock.And.Mode = true;
		ind.si = NowBlock.And.StrStart;
		end.pi = (STRING)0;
		end.si = (STRING)2;
		IdxStk.Push(end);
		return true;
	}
	bool RepeatEnd(PtnStrIdx & ind, PtnStrIdx & end)
	{
		if(NowBlock.Repeat.Count+1 < NowBlock.Repeat.CountLow){
			RepeatCountUp();
			WildRepeatAgain(ind, end);
			return true;
		}
		if(ind.pi[0] == _T('~')){
			ind.pi++;
			if(NowBlock.Repeat.Count+1 < NowBlock.Repeat.CountHigh){
				if((NowBlock.Repeat.CountHigh==INT_MAX) && (ind.si<=NowBlock.And.StrStart)) return false;
				RepeatCountUp();
				IdxStk.Push(ind);
				end.pi = (STRING)0;
				end.si = (STRING)8;
				IdxStk.Push(end);
				WildRepeatAgain(ind, end);
				return true;
			}else{
				RepeatCountUp();
				AddRepeatCountArr(ind, end, NowBlock.Repeat.Count);
				WildBlockClose();
				return true;
			}
		}
		if(NowBlock.Repeat.Count+1 < NowBlock.Repeat.CountHigh){
			if((NowBlock.Repeat.CountHigh==INT_MAX) && (ind.si<=NowBlock.And.StrStart)) return false;
			RepeatCountUp();
			IdxStk.Push(ind);
			end.pi = (STRING)0;
			end.si = (STRING)9;
			IdxStk.Push(end);
		}else RepeatCountUp();
		AddRepeatCountArr(ind, end, NowBlock.Repeat.Count);
		WildBlockClose();
		return true;
	}
	bool WildMain(const STRING & Ptn, const STRING & Str)
	{
		PtnStrIdx ind, end;
		ind.pi = Ptn;
		ind.si = Str;
		while(true){
			switch((ind.pi++)[0]){
			case _T('\0'):
				if(CaseZero(ind.si)) return true;
				break;
			case _T('*'):
				if(StrCheck(ind.si)) IdxStk.Push(ind);
				continue;
			case _T('?'):
				if(!StrCheck(ind.si)) break;
				ind.si++;
				continue;
			case _T('('):
				if(ind.pi[0] == _T('!')){
					ind.pi++;
					end = ind;
					ind.pi = ParenthesisClosePoint(ind.pi, _T('('), _T(')'));
					if(WildNegation(ind, end)) continue;
					break;
				}
				WildBlockOpen(ind, end);
				continue;
			case _T('&'):
				if(CaseAnd(ind, end)) continue;
				break;
			case _T('%'):
				if(NowBlock.And.Mode && (ind.si != NowBlock.And.StrEnd)) break;
				ind.pi = ParenthesisClosePoint(ind.pi, _T('('), _T(')'));
				if(NowBlock.Repeat.Mode){
					if(RepeatEnd(ind, end)) continue;
					break;
				}
				WildBlockClose();
				continue;
			case _T(')'):
				if(NowBlock.And.Mode && (ind.si != NowBlock.And.StrEnd)) break;
				if(NowBlock.Repeat.Mode){
					if(RepeatEnd(ind, end)) continue;
					break;
				}
				WildBlockClose();
				continue;
			case _T('\''):
				if(!StrCheck(ind.si)) break;
				if(WildClass(ind)) continue;
				break;
			case _T('"'):
				if(WildFuzzy(ind, end)) continue;
				break;
			case _T('$'):
				if(CaseEsc(ind)) continue;
				break;
			default:
				if(!StrCheck(ind.si)) break;
				if(ind.pi[-1] == (ind.si++)[0]) continue;
			}
			while(true){
				if(IdxStk.IsEmpty()) return false;
				ind = IdxStk.Pop();
				if((intptr_t)ind.pi == 0){
					if(RetMan(ind, end)) break;
					continue;
				}
				ind.si++;
				if(StrCheck(ind.si)) IdxStk.Push(ind);
				break;
			}
		}
	}

	//ʂ̊ݍmׂi_T('\0')nj
	bool ParenthesisCheck(const _TCHAR & Before, intptr_t & PtnIndex)
	{
		while(PtnTop[PtnIndex] != _T('\0')){
			switch(PtnTop[PtnIndex]){
			case _T('('):
				if(Before==_T('"')) break;
			case _T('"'):
				if(Before==_T('\'')) break;
				if(Before==_T('"')) return true;
			case _T('\''):
				if(Before==_T('\'')) return true;
				if(ParenthesisCheck(PtnTop[PtnIndex++], PtnIndex)) break;
				return false;
			case _T(')'):
				if((Before==_T('"')) || (Before==_T('\''))) break;
				if(Before==_T('(')) return true;
				return false;
			case _T('$'):
				PtnIndex++;
				if(PtnTop[PtnIndex] == _T('\0')) continue;
				break;
			}
			PtnIndex++;
		}
		return (Before==_T('\0'));
	}
	bool WildCard(const STRING & Ptn, const STRING & Str, const intptr_t & SLen)
	{
		intptr_t pi;
		PtnTop = Ptn;
		StrEnd = Str + SLen;
		//ʂݍĂ邩
		pi = 0;
		if(!ParenthesisCheck(_T('\0'), pi)) return false;
		for(pi=0; Ptn[pi] != _T('\0'); pi++){}
		CloseMapArr.SetLength(pi+1);
		DivMapArr.SetLength(pi+1);
		for(; pi >= 0; pi--){
			CloseMapArr.GetData()[pi] = 0;
			DivMapArr.GetData()[pi] = 0;
		}
		return Run(Ptn, Str);
	}

	//z֐/////////////////////////////////////////////////

	virtual intptr_t ReadCountSub(const STRING & Ptn, const STRING & Str, intptr_t & l)
	{
		intptr_t i, j, k, m;
		switch(Ptn[0]){
		case _T('['):
			if(RepeatCountArr.GetLength() <= 0){
				ReadCount(Ptn+1, Str, l);
				if(Ptn[++l] == _T('~')){
					ReadCount(Ptn+l+1, Str, k);
					l += k+1;
				}
				if(Ptn[l] == _T(']')) l++;
				return 0;
			}
			i = ReadCount(Ptn+1, Str, l)%RepeatCountArr.GetLength();
			if(i < 0) i += RepeatCountArr.GetLength();
			if(Ptn[++l] == _T('~')){
				j = ReadCount(Ptn+l+1, Str, k)%RepeatCountArr.GetLength();
				if(j < 0) j += RepeatCountArr.GetLength();
				l += k+1;
				m = 0;
				for(k = i; j-i>0?k<=j:k>=j; k+=(j-i>0?1:-1)) m += RepeatCountArr[k];
				if(Ptn[l] == _T(']')) l++;
				return m;
			}
			if(Ptn[l] == _T(']')) l++;
			return RepeatCountArr[i];
		case _T('{'):
			if(RepeatCountArr.GetLength() <= 0){
				ReadCount(Ptn+1, Str, l);
				if(Ptn[++l] == _T('~')){
					ReadCount(Ptn+l+1, Str, k);
					l += k+1;
				}
				if(Ptn[l] == _T('}')) l++;
				return 0;
			}
			i = ReadCount(Ptn+1, Str, l)%RepeatCountArr.GetLength();
			if(i < 0) i += RepeatCountArr.GetLength();
			if(Ptn[++l] == _T('~')){
				j = ReadCount(Ptn+l+1, Str, k)%RepeatCountArr.GetLength();
				if(j < 0) j += RepeatCountArr.GetLength();
				l += k+1;
				m = 0;
				for(k = i; j-i>0?k<=j:k>=j; k+=(j-i>0?1:-1)) m += RepeatCountArr.GetConst()[RepeatCountArr.GetLength()-1-k];
				if(Ptn[l] == _T('}')) l++;
				return m;
			}
			if(Ptn[l] == _T('}')) l++;
			return RepeatCountArr.GetConst()[RepeatCountArr.GetLength()-1-i];
		default:
			return ReadDigit(Ptn, l);
		}
	}
	virtual bool NegationMatch(const PtnStrIdx & ind, const PtnStrIdx & end)
	{
		PowerWildCard pwc;
		PWCArray<_TCHAR> tmp;
		tmp.AddTail(end.pi, (ind.pi-end.pi)-1);
		tmp += _T('\0');
		return pwc.SimpleMatch(tmp.GetData(), end.si, ind.si-end.si);
	}
	virtual bool StrCheck(const STRING & Str)
	{
		return (Str < StrEnd) && (!NowBlock.And.Mode || (Str < NowBlock.And.StrEnd));
	}
	virtual bool CaseZeroMain(const STRING & Str)
	{
		return (Str == StrEnd);
	}
	virtual bool RetMan(PtnStrIdx & ind, PtnStrIdx & end)
	{
		switch((intptr_t)ind.si){
		case 0://BlockOpenA
			ind = IdxStk.Pop();
			if((end.pi = NextDivisionBar(ind.pi, _T('%'), _T('('), _T(')')))!=ind.pi){
				ind.pi = end.pi;
				IdxStk.Push(ind);
				end.pi = (STRING)0;
				end.si = (STRING)0;
				IdxStk.Push(end);
				return true;
			}
			WildBlockOpenRet();
			break;
		case 1://BlockCloseA
			WildBlockCloseRet();
			break;
		case 2://AndModeA
			NowBlock.And.Mode = false;
			break;
		case 3://AddRepeatCountArrA
			RepeatCountArr.Pop();
			break;
		case 4://RepeatCountUpA
			NowBlock.Repeat.Count--;
			break;
		case 5://̌JԂ̎n܂A肻1
			ind = IdxStk.Pop();
			return true;
		case 6://̌JԂ̎n܂A肻2
			ind = IdxStk.Pop();
			AddRepeatCountArr(ind, end, 0);
			WildBlockClose();
			return true;
		case 7://xJԂA
			ind = IdxStk.Pop();
			if((end.pi = NextDivisionBar(ind.pi, _T('%'), _T('('), _T(')')))!=ind.pi){
				ind.pi = end.pi;
				IdxStk.Push(ind);
				end.pi = (STRING)0;
				end.si = (STRING)7;
				IdxStk.Push(end);
				return true;
			}
			end = IdxStk.Pop();
			if(end.pi != (STRING)0) NowBlock.And.Mode = true;
			else NowBlock.And.Mode = false;
			NowBlock.And.StrStart = end.si;
			break;
		case 8://̂xJԂO(JԂ̏I)A
			ind = IdxStk.Pop();
			AddRepeatCountArr(ind, end, NowBlock.Repeat.Count);
			WildBlockClose();
			return true;
		case 9://̌JԂ̏I(xJԂO)A
			ind = IdxStk.Pop();
			WildRepeatAgain(ind, end);
			return true;
		case 10://FuzzyMatch̕A
			if(FuzzyRet2(ind, end)) return true;
			break;
		case 11://ےA
			end = IdxStk.Pop();
			ind = IdxStk.Pop();
			if(!StrCheck(ind.si)) break;
			ind.si++;
			if(WildNegation(ind, end)) return true;
			break;
		}
		return false;
	}
	virtual bool CaseEsc(PtnStrIdx & ind)
	{
		intptr_t i;
		switch(ind.pi[0]){
		case _T('\0'):
			return CaseZero(ind.si);
		case _T('#'):
			if(!StrCheck(ind.si)) return false;
			if((_TUCHAR)ind.si[0] == ReadCount(ind.pi+1, ind.si, i)){
				ind.pi += i+1;
				ind.si++;
				return true;
			}
			return false;
		default:
			if(!StrCheck(ind.si)) return false;
			return ((ind.pi++)[0] == (ind.si++)[0]);
		}
	}

	//s
	virtual bool Run(const STRING & Ptn, const STRING & Str)
	{
		PtnStrIdx tmp;
		CloseStk.Clear();
		IdxStk.Clear();
		RepeatCountArr.Clear();
		BlockStk.Clear();
		NowBlock.And.Mode = false;
		BlockStk.Push(NowBlock);
		tmp.pi = Ptn;
		tmp.si = Str;
		WildNormal(tmp);
		return WildMain(Ptn, Str);
	}
public:////////////////////////////////////////////////////////
	//ǂ
	intptr_t ReadDigit(const STRING & Ptn, intptr_t & Length)
	{
		intptr_t i;
		i = Length = 0;
		while((_T('0') <= Ptn[Length]) && (Ptn[Length] <= _T('9'))){
			i = 10*i + (int)(Ptn[Length]-_T('0'));
			Length++;
		}
		return i;
	}
	bool SimpleMatch(const STRING Ptn, const STRING Str, const intptr_t SLen)
	{
		return WildCard(Ptn, Str, SLen);
	}
};

class PWCMatch : protected PowerWildCard
{
protected://///////////////////////////////////////////////////
	STRING StrTop;
	PWCArray<STRING> DelimiterArr;

	intptr_t ReadRepeatCount(const STRING & Ptn, intptr_t & l)
	{
		intptr_t i;
		BlockInfo tmp;
		if(Ptn[0] != _T('^')) return NowBlock.Repeat.Count;
		l++;
		if(BlockStk.IsEmpty()) return ReadRepeatCount(Ptn+1, l);
		tmp = NowBlock;
		NowBlock = BlockStk.Pop();
		i = ReadRepeatCount(Ptn+1, l);
		BlockStk.Push(NowBlock);
		NowBlock = tmp;
		return i;
	}
	bool BackwardReference(PtnStrIdx & ind)
	{
		intptr_t i, j, k, l, m;
		STRING st, en;
		i = ReadCount(ind.pi+1, ind.si, j) % (DelimiterArr.GetLength()+1);
		j++;
		if(i < 0) i += DelimiterArr.GetLength()+1;
		if(ind.pi[0] == _T(',')) i = DelimiterArr.GetLength() - i;
		if(i == 0) st = StrTop;
		else st = DelimiterArr[i-1];
		if(i == DelimiterArr.GetLength()) en = ind.si;
		else en = DelimiterArr[i];
		if(ind.pi[j] == _T('~')){
			l = ReadCount(ind.pi+(++j), ind.si, m);
			if(m > 0){
				j += m;
				l = l % (DelimiterArr.GetLength()+1);
				if(l < 0) l += DelimiterArr.GetLength()+1;
				if(ind.pi[0] == _T(',')) l = DelimiterArr.GetLength() - l;
			}else{
				if(ind.pi[0] == _T('.')) l = DelimiterArr.GetLength();
				else l = 0;
			}
			if(l > i){
				if(l == DelimiterArr.GetLength()) en = ind.si;
				else en = DelimiterArr[l];
				for(k=0; st+k < en; k++) if(!StrCheck(ind.si+k) || st[k] != ind.si[k]) return false;
			}else if(l < i){
				if(l == 0) st = StrTop;
				else st = DelimiterArr[l-1];
				for(k=-1; en+k > st-1; k--) if(!StrCheck(ind.si-k-1) || (en[k] != ind.si[-k-1])) return false;
				k = -k-1;
			}else{
				if(ind.pi[0] == _T('.')){
					for(k=0; st+k < en; k++) if(!StrCheck(ind.si+k) || st[k] != ind.si[k]) return false;
				}else{
					for(k=-1; en+k > st-1; k--) if(!StrCheck(ind.si-k-1) || (en[k] != ind.si[-k-1])) return false;
					k = -k-1;
				}
			}
		}else for(k=0; st+k < en; k++) if(!StrCheck(ind.si+k) || st[k] != ind.si[k]) return false;
		ind.pi += j;
		ind.si += k;
		return true;
	}

	//z֐/////////////////////////////////////////////////

	virtual intptr_t ReadCountSub(const STRING & Ptn, const STRING & Str, intptr_t & l)
	{
		intptr_t i, j;
		STRING st, en;
		switch(Ptn[0]){
		case _T('<'):
			i = ReadCount(Ptn+1, Str, l) % (DelimiterArr.GetLength()+1);
			if(i < 0) i += DelimiterArr.GetLength()+1;
			if(Ptn[++l] == _T('/')) i = DelimiterArr.GetLength() - i;
			if(i == 0) st = StrTop;
			else st = DelimiterArr[i-1];
			if(i == DelimiterArr.GetLength()) en = Str;
			else en = DelimiterArr[i];
			if(st >= en){
				if(Ptn[l] == _T('|') || Ptn[l] == _T('/')){
					ReadCount(Ptn+l+1, Str, j);
					l += j+1;
				}
				if(Ptn[l] == _T('>')) l++;
				return 0;
			}
			switch(Ptn[l]){
			case _T('|'):
				i = ReadCount(Ptn+l+1, Str, j) % (en-st);
				l += j+1;
				if(i < 0) i += en-st;
				break;
			case _T('/'):
				i = ReadCount(Ptn+l+1, Str, j) % (en-st);
				l += j+1;
				if(i < 0) i += en-st;
				i = en-st-1 - i;
				break;
			default:
				i = 0;
			}
			if(Ptn[l] == _T('>')) l++;
			return (_TUCHAR)st[i];
		case _T('^'):
			l = 1;
			return ReadRepeatCount(Ptn+1, l);
		default:
			return PowerWildCard::ReadCountSub(Ptn, Str, l);
		}
	}
	virtual bool NegationMatch(const PtnStrIdx & ind, const PtnStrIdx & end)
	{
		PWCMatch pwc;
		PWCArray<_TCHAR> tmp;
		tmp.AddTail(end.pi, (ind.pi-end.pi)-1);
		tmp += _T('\0');
		return pwc.Match(tmp.GetData(), end.si, ind.si-end.si);
	}
	virtual bool RetMan(PtnStrIdx & ind, PtnStrIdx & end)
	{
		switch((intptr_t)ind.si){
		case 100://d؂LʉߋA
			DelimiterArr.Pop();
			break;
		default:
			return PowerWildCard::RetMan(ind, end);
		}
		return false;
	}
	virtual bool CaseEsc(PtnStrIdx & ind)
	{
		PtnStrIdx tmp;
		switch(ind.pi[0])
		{
		case _T('\\'):
			ind.pi++;
			DelimiterArr += ind.si;
			tmp.pi = (STRING)0;
			tmp.si = (STRING)100;
			IdxStk.Push(tmp);
			return true;
		case _T('.'):
		case _T(','):
			return BackwardReference(ind);
		default:
			return PowerWildCard::CaseEsc(ind);
		}
	}
	virtual bool Run(const STRING & Ptn, const STRING & Str)
	{
		DelimiterArr.Clear();
		return PowerWildCard::Run(Ptn, Str);
	}
public:////////////////////////////////////////////////////////
	intptr_t ReadDigit(const STRING & Ptn, intptr_t & Length)
	{
		return PowerWildCard::ReadDigit(Ptn, Length);
	}
	bool Match(const STRING Ptn, const STRING Str, const intptr_t SLen)
	{
		StrTop = Str;
		return WildCard(Ptn, Str, SLen);
	}
};

class PWCSearch : protected PWCMatch
{
protected://///////////////////////////////////////////////////
	class PWCSearchNeg : protected PWCMatch
	{
	protected:
		STRING TrueStrTop, TrueStrEnd;
		virtual bool CaseEsc(PtnStrIdx & ind)
		{
			switch(ind.pi[0]){
			case _T(':'):
				ind.pi++;
				return (ind.si == TrueStrTop);
			case _T(';'):
				ind.pi++;
				return (ind.si == TrueStrEnd);
			default:
				return PWCMatch::CaseEsc(ind);
			}
		}
		virtual bool NegationMatch(const PtnStrIdx & ind, const PtnStrIdx & end)
		{
			PWCSearchNeg pwc;
			PWCArray<_TCHAR> tmp;
			tmp.AddTail(end.pi, (ind.pi-end.pi)-1);
			tmp += _T('\0');
			return pwc.Match(tmp.GetData(), TrueStrTop, TrueStrEnd, end.si, ind.si-end.si);
		}
	public:
		bool Match(const STRING Ptn, const STRING StrT, STRING StrE, const STRING StrN, const intptr_t SLenN)
		{
			TrueStrTop = StrT;
			TrueStrEnd = StrE;
			return WildCard(Ptn, StrN, SLenN);
		}
	};
	intptr_t MatchPoint, MatchLength;
	bool PrevMode;
	STRING StrMatchEnd, TrueStrTop;
	bool SearchSub(const STRING & Ptn, const STRING & Str, const intptr_t & SLen, intptr_t & Mp, intptr_t & Ml, PWCArray<STRING> & Delimiter)
	{
		if(WildCard(Ptn, Str, SLen)){
			Mp = MatchPoint;
			Ml = MatchLength;
			Delimiter = DelimiterArr;
			return true;
		}
		return false;
	}

	//z֐/////////////////////////////////////////////////

	virtual bool CaseZeroMain(const STRING & Str)
	{
		StrMatchEnd = Str;
		return true;
	}
	virtual bool CaseEsc(PtnStrIdx & ind)
	{
		switch(ind.pi[0]){
		case _T(':'):
			ind.pi++;
			return (ind.si == TrueStrTop);
		case _T(';'):
			ind.pi++;
			return (ind.si == StrEnd);
		default:
			return PWCMatch::CaseEsc(ind);
		}
	}
	virtual bool NegationMatch(const PtnStrIdx & ind, const PtnStrIdx & end)
	{
		PWCSearchNeg pwc;
		PWCArray<_TCHAR> tmp;
		tmp.AddTail(end.pi, (ind.pi-end.pi)-1);
		tmp += _T('\0');
		return pwc.Match(tmp.GetData(), TrueStrTop, StrEnd, end.si, ind.si-end.si);
	}
	virtual bool Run(const STRING & Ptn, const STRING & Str)
	{
		intptr_t i;
		for(PrevMode?i=StrEnd-Str:i=0; PrevMode?i>=0:i<=StrEnd-Str; PrevMode?i--:i++){
			if(PWCMatch::Run(Ptn, StrTop=Str+i)){
				MatchPoint = i;
				MatchLength = StrMatchEnd-StrTop;
				return true;
			}
		}
		return false;
	}
public:////////////////////////////////////////////////////////
	intptr_t ReadDigit(const STRING & Ptn, intptr_t & Length)
	{
		return PowerWildCard::ReadDigit(Ptn, Length);
	}
	bool Search(const STRING Ptn, const STRING Str, const intptr_t SLen)
	{
		intptr_t Mp, Ml;
		PWCArray<STRING> Delimiter;
		PrevMode = false;
		TrueStrTop = Str;
		return SearchSub(Ptn, Str, SLen, Mp, Ml, Delimiter);
	}
	bool Search(const STRING Ptn, const STRING Str, const intptr_t SLen, intptr_t & Mp, intptr_t & Ml)
	{
		PWCArray<STRING> Delimiter;
		PrevMode = false;
		TrueStrTop = Str;
		return SearchSub(Ptn, Str, SLen, Mp, Ml, Delimiter);
	}
	bool Search(const STRING Ptn, const STRING Str, const intptr_t SLen, intptr_t & Mp, intptr_t & Ml, PWCArray<STRING> & Delimiter)
	{
		PrevMode = false;
		TrueStrTop = Str;
		return SearchSub(Ptn, Str, SLen, Mp, Ml, Delimiter);
	}
	///////////////////////////
	//Prev
	///////////////////////////
	bool PrevSearch(const STRING Ptn, const STRING Str, const intptr_t SLen)
	{
		intptr_t Mp, Ml;
		PWCArray<STRING> Delimiter;
		PrevMode = true;
		TrueStrTop = Str;
		return SearchSub(Ptn, Str, SLen, Mp, Ml, Delimiter);
	}
	bool PrevSearch(const STRING Ptn, const STRING Str, const intptr_t SLen, intptr_t & Mp, intptr_t & Ml)
	{
		PWCArray<STRING> Delimiter;
		PrevMode = true;
		TrueStrTop = Str;
		return SearchSub(Ptn, Str, SLen, Mp, Ml, Delimiter);
	}
	bool PrevSearch(const STRING Ptn, const STRING Str, const intptr_t SLen, intptr_t & Mp, intptr_t & Ml, PWCArray<STRING> & Delimiter)
	{
		PrevMode = true;
		TrueStrTop = Str;
		return SearchSub(Ptn, Str, SLen, Mp, Ml, Delimiter);
	}
};

class PWCReplace : public PWCSearch
{
protected://///////////////////////////////////////////////////
	struct ReplaceRepeat
	{
		intptr_t rrc, rac, rpi, rsi;
		ReplaceRepeat & operator = (const ReplaceRepeat & x)
		{
			rrc = x.rrc;
			rac = x.rac;
			rpi = x.rpi;
			rsi = x.rsi;
			return *this;
		}
	};
	ReplaceRepeat rr;
	PWCStack<ReplaceRepeat> rrs;
	STRING ParenthesisClosePointRepSub(const STRING & Ptn)
	{
		intptr_t i;
		for(i = 0; Ptn[i] != _T('\0'); i++){
			if(Ptn[i] == _T(')')) return Ptn+i+1;
			if(Ptn[i] == _T('(')){
				i = ParenthesisClosePointRepSub(Ptn+i+1)-Ptn-1;
				continue;
			}
			if((Ptn[i]==_T('$')) && (Ptn[i+1]!=_T('\0'))) i++;
		}
		return Ptn+i;
	}
	//ʂƂ߂
	STRING ParenthesisClosePointRep(const STRING & Ptn)
	{
		intptr_t i;
		for(i = 0; Ptn[i] != _T('\0'); i++){
			if(Ptn[i] == _T(')')) return Ptn+i;
			if(Ptn[i] == _T('(')){
				i = ParenthesisClosePointRepSub(Ptn+i+1)-Ptn-1;
				continue;
			}
			if((Ptn[i]==_T('$')) && (Ptn[i+1]!=_T('\0'))) i++;
		}
		return Ptn+i;
	}
	intptr_t ReadRepRepeatCount(const STRING & Ptn, intptr_t & l)
	{
		intptr_t i;
		ReplaceRepeat tmp;
		if(Ptn[0] != _T('^')) return rr.rac;
		l++;
		if(rrs.IsEmpty()) return ReadRepRepeatCount(Ptn+1, l);
		tmp = rr;
		rr = rrs.Pop();
		i = ReadRepRepeatCount(Ptn+1, l);
		rrs.Push(rr);
		rr = tmp;
		return i;
	}
	intptr_t ReadCountRepSub(const STRING & Ptn, intptr_t & l)
	{
		intptr_t i, j, k, m;
		STRING st, en;
		switch(Ptn[0]){
		case _T('['):
			if(RepeatCountArr.GetLength() <= 0){
				ReadCountRep(Ptn+1, l);
				if(Ptn[++l] == _T('~')){
					ReadCountRep(Ptn+l+1, k);
					l += k+1;
				}
				if(Ptn[l] == _T(']')) l++;
				return 0;
			}
			i = ReadCountRep(Ptn+1, l)%RepeatCountArr.GetLength();
			if(i < 0) i += RepeatCountArr.GetLength();
			if(Ptn[++l] == _T('~')){
				j = ReadCountRep(Ptn+l+1, k)%RepeatCountArr.GetLength();
				if(j < 0) j += RepeatCountArr.GetLength();
				l += k+1;
				m = 0;
				for(k = i; j-i>0?k<=j:k>=j; k+=(j-i>0?1:-1)) m += RepeatCountArr[k];
				if(Ptn[l] == _T(']')) l++;
				return m;
			}
			if(Ptn[l] == _T(']')) l++;
			return RepeatCountArr[i];
		case _T('{'):
			if(RepeatCountArr.GetLength() <= 0){
				ReadCountRep(Ptn+1, l);
				if(Ptn[++l] == _T('~')){
					ReadCountRep(Ptn+l+1, k);
					l += k+1;
				}
				if(Ptn[l] == _T('}')) l++;
				return 0;
			}
			i = ReadCountRep(Ptn+1, l)%RepeatCountArr.GetLength();
			if(i < 0) i += RepeatCountArr.GetLength();
			if(Ptn[++l] == _T('~')){
				j = ReadCountRep(Ptn+l+1, k)%RepeatCountArr.GetLength();
				if(j < 0) j += RepeatCountArr.GetLength();
				l += k+1;
				m = 0;
				for(k = i; j-i>0?k<=j:k>=j; k+=(j-i>0?1:-1)) m += RepeatCountArr.GetConst()[RepeatCountArr.GetLength()-1-k];
				if(Ptn[l] == _T('}')) l++;
				return m;
			}
			if(Ptn[l] == _T('}')) l++;
			return RepeatCountArr.GetConst()[RepeatCountArr.GetLength()-1-i];
		case _T('<'):
			i = ReadCountRep(Ptn+1, l) % (DelimiterArr.GetLength()+1);
			if(i < 0) i += DelimiterArr.GetLength()+1;
			if(Ptn[++l] == _T('/')) i = DelimiterArr.GetLength() - i;
			if(i == 0) st = StrTop;
			else st = DelimiterArr[i-1];
			if(i == DelimiterArr.GetLength()) en = StrMatchEnd;
			else en = DelimiterArr[i];
			if(st >= en){
				if(Ptn[l] == _T('|') || Ptn[l] == _T('/')){
					ReadCountRep(Ptn+l+1, j);
					l += j+1;
				}
				if(Ptn[l] == _T('>')) l++;
				return 0;
			}
			switch(Ptn[l]){
			case _T('|'):
				i = ReadCountRep(Ptn+l+1, j) % (en-st);
				l += j+1;
				if(i < 0) i += en-st;
				break;
			case _T('/'):
				i = ReadCountRep(Ptn+l+1, j) % (en-st);
				l += j+1;
				if(i < 0) i += en-st;
				i = en-st-1 - i;
				break;
			default:
				i = 0;
			}
			if(Ptn[l] == _T('>')) l++;
			return (_TUCHAR)st[i];
		case _T('^'):
			l = 1;
			return ReadRepRepeatCount(Ptn+1, l);
		default:
			return ReadDigit(Ptn, l);
		}
	}
	intptr_t ReadCountRep(const STRING & Ptn, intptr_t & l)
	{
		intptr_t n, j;
		n = ReadCountRepSub(Ptn, j);
		l = j;
		while((Ptn[l] == _T('+')) || (Ptn[l] == _T('-'))){
			switch(Ptn[l]){
			case _T('+'):
				n += ReadCountRepSub(Ptn+(++l), j);
				l += j;
				break;
			case _T('-'):
				n -= ReadCountRepSub(Ptn+(++l), j);
				l += j;
				break;
			}
		}
		return n;
	}
	void CopyReplaceString(const STRING & RPtn, PWCArray<_TCHAR> & RStr, PWCArray<STRING> & Delimiter, const intptr_t & MP, const intptr_t & ML)
	{
		intptr_t i, j, k, l, m;
		STRING st, en;
		rrs.Clear();
		rr.rrc = 1;
		rr.rac = 0;
		rr.rpi = 0;
		rr.rsi = RStr.GetLength();
		for(k = 0; RPtn[k] != _T('\0'); k++){
			switch(RPtn[k]){
			case _T('('):
				rrs.Push(rr);
				rr.rrc = ReadCountRep(RPtn+k+1, j);
				if(j <= 0) rr.rrc = 1;
				else k += j;
				if(rr.rrc <= 0){
					k = ParenthesisClosePointRep(RPtn+k+1)-RPtn;
					if(RPtn[k] == _T('\0')) k--;
					rr = rrs.Pop();
					continue;
				}
				rr.rac = 0;
				rr.rpi = k;
				rr.rsi = RStr.GetLength();
				continue;
			case _T(')'):
				if(rrs.IsEmpty()){
					continue;
				}
				if(++rr.rac == rr.rrc){
					rr = rrs.Pop();
					continue;
				}
				k = rr.rpi;
				rr.rsi = RStr.GetLength();
				continue;
			case _T('$'):
				switch(RPtn[++k]){
				case _T('.'):
					i = ReadCountRep(RPtn+k+1, j) % (Delimiter.GetLength()+1);
					if(i < 0) i += Delimiter.GetLength()+1;
					if(i == 0) st = StrTop;
					else st = Delimiter[i-1];
					if(i == Delimiter.GetLength()) en = StrMatchEnd;
					else en = Delimiter[i];
					if(RPtn[k+j+1] == _T('~')){
						l = ReadCountRep(RPtn+k+(++j)+1, m);
						if(m > 0){
							j += m;
							l = l % (Delimiter.GetLength()+1);
							if(l < 0) l += Delimiter.GetLength()+1;
							if(l >= i){
								if(l == Delimiter.GetLength()) en = StrMatchEnd;
								else en = Delimiter[l];
								RStr.AddTail(st, en-st);
							}else{
								if(l == 0) st = StrTop;
								else st = Delimiter[l-1];
								for(i=-1; en+i > st-1; i--) RStr += en[i];
							}
						}else RStr.AddTail(st, StrMatchEnd-st);
					}else RStr.AddTail(st, en-st);
					k += j;
					continue;
				case _T(','):
					i = ReadCountRep(RPtn+k+1, j) % (Delimiter.GetLength()+1);
					if(i < 0) i += Delimiter.GetLength()+1;
					i = Delimiter.GetLength() - i;
					if(i == 0) st = StrTop;
					else st = Delimiter[i-1];
					if(i == Delimiter.GetLength()) en = StrMatchEnd;
					else en = Delimiter[i];
					if(RPtn[k+j+1] == _T('~')){
						l = ReadCountRep(RPtn+k+(++j)+1, m);
						if(m > 0){
							j += m;
							l = l % (Delimiter.GetLength()+1);
							if(l < 0) l += Delimiter.GetLength()+1;
							l = Delimiter.GetLength() - l;
							if(l > i){
								if(l == Delimiter.GetLength()) en = StrMatchEnd;
								else en = Delimiter[l];
								RStr.AddTail(st, en-st);
							}else{
								if(l == 0) st = StrTop;
								else st = Delimiter[l-1];
								for(i=-1; en+i > st-1; i--) RStr += en[i];
							}
						}else for(i=-1; en+i > StrTop-1; i--) RStr += en[i];
					}else RStr.AddTail(st, en-st);
					k += j;
					continue;
				case _T('#'):
					RStr += (_TUCHAR)ReadCountRep(RPtn+k+1, j);
					k += j;
					continue;
				case _T('='):
					{
						PWCReplace pwcr;
						PWCArray<_TCHAR> tmps, tmpr, tmpa;
						j = 0;
						for(i = k+1; RPtn[i] != _T('\0'); i++){
							if(RPtn[i] == _T('$')){
								if(RPtn[++i] == _T('=')){
									i--;
									j = 2;
									break;
								}
								if(RPtn[i] == _T('\0')) break;
							}
						}
						tmps.AddTail(RPtn+k+1, i-k-1);
						tmps += _T('\0');
						i += j;
						k = ParenthesisClosePointRep(RPtn+i)-RPtn-1;
						tmpr.AddTail(RPtn+i, k-i+1);
						tmpr += _T('\0');
						pwcr.ReplaceAll(tmps.GetData(), RStr.GetData()+rr.rsi, RStr.GetLength()-rr.rsi, tmpr.GetData(), tmpa);
						RStr.SetLength(rr.rsi);
						RStr += tmpa;
					}
					continue;
				}
				if(RPtn[k] == _T('\0')) return;
			default:
				RStr += RPtn[k];
			}
		}
	}
	bool ReplaceNextSub(const STRING & Ptn, const STRING & Str, const intptr_t & SLen, const STRING & RPtn, PWCArray<_TCHAR> & RStr, intptr_t & Mp, intptr_t & Ml, PWCArray<STRING> & Delimiter)
	{
		TrueStrTop = Str;
		if(!SearchSub(Ptn, Str, SLen, Mp, Ml, Delimiter)) return false;
		RStr.AddTail(Str, Mp);
		CopyReplaceString(RPtn, RStr, Delimiter, Mp, Ml);
		RStr.AddTail(Str+Mp+Ml, SLen-Mp-Ml);
		return true;
	}
	bool ReplaceAllSub(const STRING & Ptn, const STRING & Str, const intptr_t & SLen, const STRING & RPtn, PWCArray<_TCHAR> & RStr)
	{
		intptr_t amp, aml, i;
		PWCArray<STRING> Delimiter;
		TrueStrTop = Str;
		i = -1;
		amp = aml = 0;
		do{
			if(amp+aml > 0)	i += amp+aml;
			else if(++i > 0) RStr += Str[i-1];
			if(!SearchSub(Ptn, Str+i, SLen-i, amp, aml, Delimiter)) break;
			RStr.AddTail(Str+i, amp);
			CopyReplaceString(RPtn, RStr, Delimiter, amp, aml);
		}while(i < SLen);
		RStr.AddTail(Str+i, SLen-i);
		return i > 0;
	}
public:////////////////////////////////////////////////////////
	bool ReplaceNext(const STRING Ptn, const STRING Str, const intptr_t SLen, const STRING RPtn, PWCArray<_TCHAR> & RStr)
	{
		intptr_t Mp, Ml;
		PWCArray<STRING> Delimiter;
		PrevMode = false;
		return ReplaceNextSub(Ptn, Str, SLen, RPtn, RStr, Mp, Ml, Delimiter);
	}
	bool ReplaceNext(const STRING Ptn, const STRING Str, const intptr_t SLen, const STRING RPtn, PWCArray<_TCHAR> & RStr, intptr_t & Mp, intptr_t & Ml)
	{
		PWCArray<STRING> Delimiter;
		PrevMode = false;
		return ReplaceNextSub(Ptn, Str, SLen, RPtn, RStr, Mp, Ml, Delimiter);
	}
	bool ReplaceNext(const STRING Ptn, const STRING Str, const intptr_t SLen, const STRING RPtn, PWCArray<_TCHAR> & RStr, intptr_t & Mp, intptr_t & Ml, PWCArray<STRING> & Delimiter)
	{
		PrevMode = false;
		return ReplaceNextSub(Ptn, Str, SLen, RPtn, RStr, Mp, Ml, Delimiter);
	}
	///////////////////////////
	bool ReplaceAll(const STRING Ptn, const STRING Str, const intptr_t SLen, const STRING RPtn, PWCArray<_TCHAR> & RStr)
	{
		PrevMode = false;
		return ReplaceAllSub(Ptn, Str, SLen, RPtn, RStr);
	}
	///////////////////////////
	//Prev
	///////////////////////////
	bool PrevReplaceNext(const STRING Ptn, const STRING Str, const intptr_t SLen, const STRING RPtn, PWCArray<_TCHAR> & RStr)
	{
		intptr_t Mp, Ml;
		PWCArray<STRING> Delimiter;
		PrevMode = true;
		return ReplaceNextSub(Ptn, Str, SLen, RPtn, RStr, Mp, Ml, Delimiter);
	}
	bool PrevReplaceNext(const STRING Ptn, const STRING Str, const intptr_t SLen, const STRING RPtn, PWCArray<_TCHAR> & RStr, intptr_t & Mp, intptr_t & Ml)
	{
		PWCArray<STRING> Delimiter;
		PrevMode = true;
		return ReplaceNextSub(Ptn, Str, SLen, RPtn, RStr, Mp, Ml, Delimiter);
	}
	bool PrevReplaceNext(const STRING Ptn, const STRING Str, const intptr_t SLen, const STRING RPtn, PWCArray<_TCHAR> & RStr, intptr_t & Mp, intptr_t & Ml, PWCArray<STRING> & Delimiter)
	{
		PrevMode = true;
		return ReplaceNextSub(Ptn, Str, SLen, RPtn, RStr, Mp, Ml, Delimiter);
	}
};
