
#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"zlib.lib")

#include <windows.h>
#include <process.h>
#include <comdef.h>
#include <tchar.h>
#include <time.h>
#include <math.h>
#include <zlib.h>
static const unsigned char ASCII_FLAG  = 0x01; /* bit 0 set: file probably ascii text */
static const unsigned char HEAD_CRC    = 0x02; /* bit 1 set: header CRC present */
static const unsigned char EXTRA_FIELD = 0x04; /* bit 2 set: extra field present */
static const unsigned char ORIG_NAME   = 0x08; /* bit 3 set: original file name present */
static const unsigned char COMMENT     = 0x10; /* bit 4 set: file comment present */
static const unsigned char RESERVED    = 0xE0; /* bits 5..7: reserved */
#include "myintdef.h"
#include "PowerWildCard.h"


void* (__stdcall *sszrefnewfunc)(intptr_t);
void (__stdcall *sszrefdeletefunc)(void*);

#include "../../ssz/ssz/typeid.h"
#include "../../ssz/ssz/arrayandref.hpp"
#include "../../ssz/ssz/benry.hpp"

int32_t ransuutane;
HINSTANCE ghInstance;

BOOL WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved)
{
	switch(fdwReason)
	{
	case DLL_PROCESS_ATTACH:
		ghInstance = hinstDLL;
		ransuutane = (int32_t)time(NULL);
		ransuutane ^= timeGetTime()<<16;
		break;
	case DLL_PROCESS_DETACH:
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	}
	return TRUE;
}

TUserFunc(void, Message, Reference r)
{
	ben->SetSSZFunc();
	PWCArray<wchar_t> str;
	ben->ReftoWstr(str, r);
	MessageBox(NULL, str.GetConst(), _T("bZ[W"), MB_OK);
}

TUserFunc(bool, YesNo, Reference r)
{
	ben->SetSSZFunc();
	PWCArray<wchar_t> str;
	ben->ReftoWstr(str, r);
	return MessageBox(NULL, str.GetConst(), _T("bZ[W"), MB_YESNO) == IDYES;
}

template<typename T> void XToStr(Benry *ben, Reference *r, T x)
{
	_variant_t comvar;
	ben->SetSSZFunc();
	comvar = x;
	ben->WstrtoRef(*r, (LPTSTR)(_bstr_t)comvar);
}

TUserFunc(void, DoubleToStr, double dbl, Reference *r)
{
	XToStr(ben, r, dbl);
}

TUserFunc(uint32_t, TickCount)
{
	return timeGetTime();
}

TUserFunc(void, Delay, uint32_t ui)
{
	Sleep(ui);
}

TUserFunc(bool, GetClipboardStr, Reference *r)
{
	ben->SetSSZFunc();
	HANDLE hText;
	wchar_t *pText;
	OpenClipboard(NULL);
	hText = GetClipboardData(CF_UNICODETEXT);
	if(hText == NULL) return false;
	pText = (wchar_t*)GlobalLock(hText);
	ben->WstrtoRef(*r, pText);
	GlobalUnlock(hText);
	CloseClipboard();
	return true;
}

TUserFunc(bool, ShellOpen, bool act, bool wait, Reference direct, Reference param, Reference file)
{
	ben->SetSSZFunc();
	PWCArray<wchar_t> f, p, d;
	SHELLEXECUTEINFO sei;
	ben->ReftoWstr(f, file);
	ben->ReftoWstr(p, param);
	ben->ReftoWstr(d, direct);
	sei.cbSize		 = sizeof(sei);
	sei.fMask		 = SEE_MASK_NOCLOSEPROCESS;
	sei.hwnd		 = 0;
	sei.lpVerb		 = _T("open");
	sei.lpFile		 = f.GetConst();
	sei.lpParameters = p.GetConst();
	sei.lpDirectory  = d.GetConst();
	sei.nShow		 = (act ? SW_SHOWNA : SW_NORMAL);
	if(ShellExecuteEx(&sei)){
		if(wait) WaitForSingleObject(sei.hProcess, INFINITE);
	}else{
		return false;
	}
	return true;
}

TUserFunc(bool, PwcReplace, Reference *pdst, Reference tikan, Reference kensaku, Reference src)
{
	ben->SetSSZFunc();
	PWCArray<wchar_t> tmp1, tmp2, tmp3;
	PWCReplace pcas;
	bool ret;
	ben->ReftoWstr(tmp1, kensaku);
	ben->ReftoWstr(tmp2, tikan);
	ret = !src.null() && pcas.ReplaceAll(tmp1.GetConst(), (wchar_t*)src.atpos(), src.len()/sizeof(wchar_t), tmp2.GetConst(), tmp3);
	pdst->releaseanddelete();
	pdst->refnew(tmp3.GetLength(), sizeof(wchar_t));
	if(pdst->len() > 0){
		memcpy(pdst->atpos(), tmp3.GetConst(), tmp3.GetLength()*sizeof(wchar_t));
	}
	return ret;
}

TUserFunc(intptr_t, TazyuuCheck, Reference name)
{
	ben->SetSSZFunc();
	PWCArray<wchar_t> tmp;
	HANDLE hMutex;
	SECURITY_ATTRIBUTES securityatt;
	ben->ReftoWstr(tmp, name);
	securityatt.nLength = sizeof(securityatt);
	securityatt.lpSecurityDescriptor = NULL;
	securityatt.bInheritHandle = FALSE;
	hMutex = CreateMutex(&securityatt, FALSE, tmp.GetConst());
	if(GetLastError() == ERROR_ALREADY_EXISTS){
		CloseHandle(hMutex);
		hMutex = NULL;
	}
	return (intptr_t)hMutex;
}

TUserFunc(void, CloseTazyuuHandle, intptr_t mutex)
{
    ReleaseMutex((HANDLE)mutex);
    CloseHandle((HANDLE)mutex);
}

TUserFunc(void, GetInifileString, Reference *pstr, Reference def, Reference key, Reference app, Reference file)
{
	ben->SetSSZFunc();
	PWCArray<wchar_t> tmp1, tmp2, tmp3, tmp4, tmp5;
	wchar_t * pws;
	ben->ReftoWstr(tmp1, file);
	pws = _wfullpath(NULL, tmp1.GetConst(), 0);
	if(pws != NULL){
		tmp1 = pws;
		tmp1 += L'\0';
		free(pws);
	}
	ben->ReftoWstr(tmp2, app);
	ben->ReftoWstr(tmp3, key);
	ben->ReftoWstr(tmp4, def);
	tmp5.SetLength(256);
	GetPrivateProfileString(tmp2.GetConst(), tmp3.GetConst(), tmp4.GetConst(),
		tmp5.GetData(), (DWORD)tmp5.GetLength(), tmp1.GetConst());
	ben->WstrtoRef(*pstr, tmp5.GetConst());
}

TUserFunc(int32_t, GetInifileInt, int32_t def, Reference key, Reference app, Reference file)
{
	ben->SetSSZFunc();
	PWCArray<wchar_t> tmp1, tmp2, tmp3;
	wchar_t * pws;
	ben->ReftoWstr(tmp1, file);
	pws = _wfullpath(NULL, tmp1.GetConst(), 0);
	if(pws != NULL){
		tmp1 = pws;
		tmp1 += L'\0';
		free(pws);
	}
	ben->ReftoWstr(tmp2, app);
	ben->ReftoWstr(tmp3, key);
	return GetPrivateProfileInt(tmp2.GetConst(), tmp3.GetConst(), def, tmp1.GetConst());
}

TUserFunc(bool, WriteInifileString, Reference str, Reference key, Reference app, Reference file)
{
	ben->SetSSZFunc();
	PWCArray<wchar_t> tmp1, tmp2, tmp3, tmp4;
	wchar_t * pws;
	ben->ReftoWstr(tmp1, file);
	pws = _wfullpath(NULL, tmp1.GetConst(), 0);
	if(pws != NULL){
		tmp1 = pws;
		tmp1 += L'\0';
		free(pws);
	}
	ben->ReftoWstr(tmp2, app);
	ben->ReftoWstr(tmp3, key);
	ben->ReftoWstr(tmp4, str);
	return WritePrivateProfileString(tmp2.GetConst(), tmp3.GetConst(), tmp4.GetConst(), tmp1.GetConst()) != 0;
}

TUserFunc(int64_t, UnixTime)
{
	return time(NULL);
}

TUserFunc(int32_t, Ransuu)
{
	int32_t w;
	w = ransuutane / 127773;
	if((ransuutane = (ransuutane - w * 127773) * 16807 - w * 2836) <= 0) ransuutane += 2147483647L;
	return ransuutane;
}

TUserFunc(void, Srand, int32_t seed)
{
	ransuutane = seed;
}

TUserFunc(double, Power, double y, double x)
{
	return pow(x, y);
}


int HeadCheck(const char *const buf, intptr_t len)
{
	int i = 0;
	if(len < 10 || buf[i++] != '\x1f' || buf[i++] != '\x8b'){
		return -1;
	}
	int method = buf[i++];
	int flags  = buf[i++];
	if(method != Z_DEFLATED || (flags & RESERVED) != 0){
		return -1;
	}
	i += 6;
	if(flags & EXTRA_FIELD){
		int len = (unsigned char)buf[i++];
		len += ((int)(unsigned char)buf[i++] << 8);
		i += len;
	}
	if(flags & ORIG_NAME){
		while(i < len) if(buf[i++] == 0) break;
	}
	if(flags & COMMENT){
		while(i < len) if(buf[i++] == 0) break;
	}
	if(flags & HEAD_CRC){
		i += 2;
	}
	if(i > len) return -1;
	return i;
}

TUserFunc(bool, UnCompress, Reference src, Reference *dst)
{
	ben->SetSSZFunc();
	z_stream z;
	intptr_t hsize;
	char outbuf[4096];
	int status;
	PWCArray<char> mainbuf;
	if(src.len() == 0) return false;
	if((hsize = HeadCheck((char*)src.atpos(), src.len())) < 0) hsize = 0;
	z.zalloc = Z_NULL;
	z.zfree = Z_NULL;
	z.opaque = Z_NULL;
	z.next_in = Z_NULL;
	z.avail_in = 0;
	if(hsize > 0){
		if(inflateInit2(&z, -MAX_WBITS) != Z_OK) return false;
	}else{
		if(inflateInit(&z) != Z_OK) return false;
	}
	z.next_in = (BYTE *)src.atpos()+hsize;
	z.avail_in = (uInt)(src.len()-hsize);
	z.next_out = (BYTE *)outbuf; 
	z.avail_out = (uInt)sizeof(outbuf);
	do{
		if(z.avail_out == 0){
			mainbuf.AddTail(outbuf, sizeof(outbuf));
			z.next_out = (Bytef*)outbuf;
			z.avail_out = sizeof(outbuf);
		}
		status = inflate(&z, Z_NO_FLUSH);
	}while(status == Z_OK);
	if(status != Z_STREAM_END){
		inflateEnd(&z);
		return false;
	}
	mainbuf.AddTail(outbuf, sizeof(outbuf) - z.avail_out);
	inflateEnd(&z);
	dst->releaseanddelete();
	dst->refnew(mainbuf.GetLength(), sizeof(int8_t));
	if(dst->len() > 0) memcpy(dst->atpos(), mainbuf.GetConst(), mainbuf.GetLength());
	return true;
}

TUserFunc(void, UbytesToStr, Reference src, Reference *dst, UINT cp)
{
	ben->SetSSZFunc();
	dst->releaseanddelete();
	if(src.len() == 0) return;
	dst->refnew(MultiByteToWideChar(cp, 0, (LPCSTR)src.atpos(), (int)src.len(), NULL, 0), sizeof(wchar_t));
	if(dst->len() > 0) MultiByteToWideChar(cp, 0, (LPCSTR)src.atpos(), (int)src.len(), (wchar_t*)dst->atpos(), (int)dst->len()/sizeof(wchar_t));
}










#include "mydll.h"

// Data Structures
typedef struct tagXFERBUFFER2
{
	_TCHAR *lpszTitle;
	LPTSTR *lpszBuffer;
	int *length;
}XFERBUFFER2;
//Prototyping
BOOL WINAPI InputBoxDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
int WINAPI WEP(int nShutDownFlag);
/*******************************************/ 
/* THE FOLLOWING FUNCTION  (WEP) IS    */ 
/* NEEDED FOR EVERY .DLL                   */ 
/*******************************************/ 
int WINAPI WEP(int nShutDownFlag)
{
	return 1;
}
/*******************************************/ 
/* THE FOLLOWING FUNCTION  (MyInputBox) IS*/ 
/* WHAT THE FOXPRO .PRG CALLS*/ 
/*******************************************/ 
/*******************************************/ 
INT_PTR WINAPI MyInputBox(HWND hWndParent, LPTSTR lpszTitle, LPTSTR *Buffer, int *Length)
{
	DLGPROC lpfnInputBoxDlgProc;
	XFERBUFFER2 XferBuffer;
	INT_PTR Result;
	XferBuffer.lpszTitle = (_TCHAR *)lpszTitle;
	XferBuffer.lpszBuffer = Buffer;
	XferBuffer.length = Length;
	lpfnInputBoxDlgProc = (DLGPROC)MakeProcInstance((FARPROC)InputBoxDlgProc,
		ghInstance);
	Result=DialogBoxParam(ghInstance,_T("INPUTDIALOG"),
		hWndParent,lpfnInputBoxDlgProc,(LPARAM)&XferBuffer);
	FreeProcInstance((FARPROC)lpfnInputBoxDlgProc);
	return Result;
}
/*******************************************/ 
BOOL WINAPI InputBoxDlgProc(HWND hDlg, UINT message,WPARAM wParam, LPARAM lParam)
{
	static XFERBUFFER2 *XferBuffer;
	switch(message)
	{
	case WM_INITDIALOG :
		{
			XferBuffer = (XFERBUFFER2*)lParam;
			SetWindowText(hDlg, XferBuffer->lpszTitle);
			return TRUE; 
		}
	case WM_COMMAND :
		{
			switch(wParam)
			{
			case IDOK :
				{
					int NumChars;
					*XferBuffer->length = GetWindowTextLength(GetDlgItem(hDlg,IDD_EDIT));
					*XferBuffer->lpszBuffer = new _TCHAR[*XferBuffer->length + 1];
					NumChars=GetDlgItemText(hDlg,IDD_EDIT,
						*XferBuffer->lpszBuffer,
						*XferBuffer->length + 1);
					EndDialog(hDlg,NumChars);
					break; 
				}
			case IDCANCEL :
				{
					EndDialog(hDlg, 0);
					break;
				}
			}
		}
	}
	return FALSE;
}

TUserFunc(void, InputStr, Reference *pr)
{
	ben->SetSSZFunc();
	wchar_t * str;
	int len;
	len = -1;
	str = NULL;
	MyInputBox(NULL, _T(""), &str, &len);
	if(len >= 0){
		ben->WstrtoRef(*pr, str);
	}else{
		pr->releaseanddelete();
	}
}
