#define WIN32_LEAN_AND_MEAN
#define _WIN32_IE 0x0500
#include <windows.h>
#include <shellapi.h>
#include <process.h>

#include "myintdef.h"
#include "PowerWildCard.h"


void* (__stdcall *sszrefnewfunc)(intptr_t);
void (__stdcall *sszrefdeletefunc)(void*);

#include "../../ssz/ssz/typeid.h"
#include "../../ssz/ssz/arrayandref.hpp"
#include "../../ssz/ssz/benry.hpp"

HWND g_hwnd;
RECT g_rect;
intptr_t g_cbproc;
SSZCALLBACK g_callback;
void *g_handle;
NOTIFYICONDATA g_NID;
const UINT WM_TRAYICON = WM_USER;
bool g_ranning = false, g_intray = false;


struct TextStruct
{
	HFONT hFont;
	COLORREF color;
	int x, y;
	PWCArray<wchar_t> str;
	TextStruct()
	{
		hFont = NULL;
	}
	~TextStruct()
	{
		DeleteObject(hFont);
	}
};

HDC g_bghdc;
HBITMAP g_bghbm;
PWCArray<TextStruct *> g_textbuffer;
HMENU g_hmenu = NULL;
PWCArray<intptr_t> g_menucallback;

void Draw(HWND hwnd)
{
	PAINTSTRUCT ps;
	HGDIOBJ oldf;
	COLORREF oldc;
	HDC hdc;
	HBITMAP hbm;
	int i;
	if(GetUpdateRect(hwnd,NULL,TRUE) == FALSE) return;
	BeginPaint(hwnd, &ps);
	hdc = CreateCompatibleDC(ps.hdc);
	hbm = CreateCompatibleBitmap(ps.hdc, g_rect.right, g_rect.bottom);
	SelectObject(hdc, hbm);
	SetBkMode(hdc, TRANSPARENT);
	BitBlt(hdc, 0, 0, g_rect.right, g_rect.bottom, g_bghdc, 0, 0, SRCCOPY);
	for(i = 0; i < g_textbuffer.GetLength(); i++){
		oldf = SelectObject(hdc, g_textbuffer.GetConst()[i]->hFont);
		oldc = SetTextColor(hdc, g_textbuffer.GetConst()[i]->color);
		TextOut(hdc, g_textbuffer.GetConst()[i]->x, g_textbuffer.GetConst()[i]->y,
			g_textbuffer.GetConst()[i]->str.GetConst(), (int)g_textbuffer.GetConst()[i]->str.GetLength()-1);
		//SetTextColor(hdc, oldc);
		//SelectObject(hdc, oldf);
	}
	BitBlt(ps.hdc, 0, 0, g_rect.right, g_rect.bottom, hdc, 0, 0, SRCCOPY);
	DeleteDC(hdc);
	DeleteObject(hbm);
	EndPaint(hwnd, &ps);
}

void BufClear()
{
	int i;
	for(i = 0; i < g_textbuffer.GetLength(); i++){
		delete g_textbuffer.GetConst()[i];
	}
	g_textbuffer.Clear();
}

void InTray()
{
	PWCArray<wchar_t> str;
	str.SetLength(GetWindowTextLength(g_hwnd)+1);
	GetWindowText(g_hwnd, str.GetData(), (int)str.GetLength());
	ShowWindow(g_hwnd, SW_HIDE);
	g_NID.cbSize = sizeof(g_NID);
	g_NID.hIcon = LoadIcon(GetModuleHandle(NULL), _T("SSZIcon"));
	g_NID.hWnd = g_hwnd;
	if(str.GetLength() > 128) str.GetData()[127] = L'\0';
	lstrcpy(g_NID.szTip, str.GetConst());
	g_NID.uCallbackMessage = WM_TRAYICON;
	g_NID.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	Shell_NotifyIcon(NIM_ADD, &g_NID);
	g_intray = true;
}

void OutTray()
{
	Shell_NotifyIcon(NIM_DELETE, &g_NID);
	ShowWindow(g_hwnd, SW_SHOW);
	g_intray = false;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	__declspec(align(4)) struct{//͋t
		LPARAM lParam;
		WPARAM wParam;
		UINT iMsg;
	} hikis;
	hikis.iMsg = iMsg;
	hikis.wParam = wParam;
	hikis.lParam = lParam;
	if(iMsg == WM_CREATE){
		PAINTSTRUCT ps;
		HBRUSH hbr;
		BeginPaint(hwnd, &ps);
		g_bghdc = CreateCompatibleDC(ps.hdc);
		g_bghbm = CreateCompatibleBitmap(ps.hdc, g_rect.right, g_rect.bottom);
		EndPaint(hwnd, &ps);
		SelectObject(g_bghdc, g_bghbm);
		SetBkMode(g_bghdc, TRANSPARENT);
		hbr = CreateSolidBrush(RGB(0, 0, 0));
		FillRect(g_bghdc, &g_rect, hbr);
		DeleteObject(hbr);
		g_hwnd = hwnd;
	}
	if(*(bool *)g_callback(g_handle, g_cbproc, &hikis, sizeof(hikis), sizeof(bool))){
		InvalidateRect(hwnd, &g_rect, TRUE);
		UpdateWindow(hwnd);
		return 0;
	}
	switch(iMsg){
	case WM_PAINT:
		Draw(hwnd);
		break;
	case WM_DESTROY:
		if(g_intray){
			Shell_NotifyIcon(NIM_DELETE, &g_NID);
			g_intray = false;
		}
		PostQuitMessage(0);
		break;
	case WM_TRAYICON:
		switch(lParam)
		{
		case WM_LBUTTONUP:
			OutTray();
			break;
		default:
			PostMessage(hwnd, (UINT)lParam, wParam, 0);
			break;
		}
		break;
	case WM_COMMAND:
		if(LOWORD(wParam) >= g_menucallback.GetLength()) break;
		g_callback(g_handle, g_menucallback.GetConst()[LOWORD(wParam)], NULL, 0, 0);
		break;
	default:
		if(g_intray && iMsg == RegisterWindowMessage(_T("TaskbarCreated"))) InTray();
		return DefWindowProc(hwnd,iMsg,wParam,lParam);
	}
	return 0;
}


TUserFunc(void, Strat, intptr_t cbfunc, int32_t height, int32_t width, Reference t)
{
	ben->SetSSZFunc();
	PWCArray<wchar_t> str;
	int32_t x, y, w, h;
	HWND hwnd;
	WNDCLASS wndclass;
	MSG  msg;
	if(!g_ranning){
		g_ranning = true;
		g_cbproc = cbfunc;
		g_callback = ben->callback;
		g_handle = ben->handle;
		ben->ReftoWstr(str, t);
		wndclass.style         = CS_DBLCLKS;
		wndclass.lpfnWndProc   = WndProc;
		wndclass.cbClsExtra    = 0;
		wndclass.cbWndExtra    = 0;
		wndclass.hInstance     = GetModuleHandle(NULL);
		wndclass.hIcon         = LoadIcon(GetModuleHandle(NULL), _T("SSZIcon"));
		wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW);
		wndclass.hbrBackground = NULL;
		wndclass.lpszMenuName  = NULL;
		wndclass.lpszClassName = str.GetConst();
		RegisterClass(&wndclass);
		g_rect.left = g_rect.top = 0;
		w = g_rect.right = width;
		h = g_rect.bottom = height;
		w += GetSystemMetrics(SM_CXFIXEDFRAME)*2;
		h += GetSystemMetrics(SM_CYFIXEDFRAME)*2 + GetSystemMetrics(SM_CYCAPTION);
		x = GetSystemMetrics(SM_CXSCREEN)/2 - w/2;
		y = GetSystemMetrics(SM_CYSCREEN)/2 - h/2;
		hwnd = CreateWindowEx(0, str.GetConst(), str.GetConst(),
			WS_POPUP | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX, x, y, w, h, NULL, NULL, GetModuleHandle(NULL), NULL);
		UpdateWindow(hwnd);
		ShowWindow(hwnd, SW_SHOW);
		while(GetMessage(&msg,NULL,0,0)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		BufClear();
		DeleteDC(g_bghdc);
		DeleteObject(g_bghbm);
		g_menucallback.Clear();
		DestroyMenu(g_hmenu);
		g_hmenu = NULL;
		g_ranning = false;
		g_intray = false;
	}
}

TUserFunc(void, Fill, int32_t h, int32_t w, int32_t y, int32_t x, uint32_t c)
{
	if(g_ranning){
		HBRUSH hbr;
		RECT r;
		r.left = x;
		r.top = y;
		r.right = x + w;
		r.bottom = y + h;
		hbr = CreateSolidBrush(c);
		FillRect(g_bghdc, &r, hbr);
		DeleteObject(hbr);
	}
}

TUserFunc(void, Clear)
{
	BufClear();
}

TUserFunc(void, StaticText, Reference text, int32_t y, int32_t x, Reference font, int16_t size, uint32_t color)
{
	ben->SetSSZFunc();
	if(size != 0){
		PWCArray<wchar_t> tmp;
		TextStruct *pts = new TextStruct;
		ben->ReftoWstr(tmp, font);
		pts->hFont = CreateFont(size, 0, 0, 0, FW_DONTCARE, FALSE, FALSE, FALSE,
			DEFAULT_CHARSET, OUT_CHARACTER_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_DONTCARE | DEFAULT_PITCH, tmp.GetConst());
		pts->color = color;
		pts->x = x;
		pts->y = y;
		ben->ReftoWstr(pts->str, text);
		g_textbuffer += pts;
	}
}

TUserFunc(void, Print, Reference text, int32_t y, int32_t x, Reference font, int16_t size, uint32_t color)
{
	if(g_ranning && size != 0){
		ben->SetSSZFunc();
		HGDIOBJ oldf;
		COLORREF oldc;
		PWCArray<wchar_t> tmp, str;
		HFONT hf;
		ben->ReftoWstr(tmp, font);
		hf = CreateFont(size, 0, 0, 0, FW_DONTCARE, FALSE, FALSE, FALSE,
			DEFAULT_CHARSET, OUT_CHARACTER_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_DONTCARE | DEFAULT_PITCH, tmp.GetConst());
		oldf = SelectObject(g_bghdc, hf);
		oldc = SetTextColor(g_bghdc, color);
		ben->ReftoWstr(str, text);
		TextOut(g_bghdc, x, y, str.GetConst(), (int)str.GetLength()-1);
		SetTextColor(g_bghdc, oldc);
		SelectObject(g_bghdc, oldf);
		DeleteObject(hf);
	}
}

TUserFunc(void, Close)
{
	if(g_ranning) PostMessage(g_hwnd, WM_CLOSE, 0, 0);
}

TUserFunc(void, IntoTaskTray)
{
	if(!g_intray) InTray();
}

TUserFunc(void, OutofTaskTray)
{
	if(g_intray) OutTray();
}

TUserFunc(bool, IsInTaskTray)
{
	return g_intray;
}

TUserFunc(void, ShowBalloonTip, Reference text)
{
	ben->SetSSZFunc();
	if(g_intray){
		intptr_t len = text.len()/sizeof(wchar_t) > 255 ? 255 : text.len()/sizeof(wchar_t);
		PWCArray<wchar_t> str;
		str.SetLength(GetWindowTextLength(g_hwnd)+1);
		GetWindowText(g_hwnd, str.GetData(), (int)str.GetLength());
		g_NID.uFlags = NIF_INFO;
		if(str.GetLength() > 256) str.GetData()[255] = L'\0';
		lstrcpy(g_NID.szInfoTitle, str.GetConst());
		memcpy(g_NID.szInfo, text.atpos(), len*sizeof(wchar_t));
		g_NID.szInfo[len] = _T('\0');
		g_NID.dwInfoFlags = NIIF_NONE;
		Shell_NotifyIcon(NIM_MODIFY, &g_NID);
	}
}

TUserFunc(int16_t, KeyState, int32_t key)
{
	return GetAsyncKeyState(key);
}

TUserFunc(void, Update)
{
	if(g_ranning){
		InvalidateRect(g_hwnd, &g_rect, TRUE);
		UpdateWindow(g_hwnd);
	}
}


bool MakeMenu(HMENU &hmenu, PWCArray<intptr_t> &proc, Benry &ben, const Reference &menu, const int32_t classid, const int32_t procid, bool root)
{
	__declspec(align(1)) struct MenuItem{//͋t
		Reference name;
		DynamicRef node;
	};
	if(menu.len() == 0){
		hmenu = NULL;
		return true;
	}
	int i;
	PWCArray<wchar_t> str;
	hmenu = (root ? CreateMenu() : CreatePopupMenu());
	for(i = 0; i < menu.len(); i += sizeof(MenuItem)){
		ben.ReftoWstr(str, ((MenuItem*)menu.refat<1>(i))->name);
		if(((MenuItem*)menu.refat<1>(i))->node.obj.len() == 0){
			DestroyMenu(hmenu);
			proc.Clear();
			return false;
		}
		if(((MenuItem*)menu.refat<1>(i))->node.typ == classid){
			HMENU hpm;
			MakeMenu(hpm, proc, ben, ((MenuItem*)menu.refat<1>(i))->node.obj, classid, procid, false);
			AppendMenu(hmenu, MF_POPUP, (UINT_PTR)hpm, str.GetConst());
		}else if(((MenuItem*)menu.refat<1>(i))->node.typ == procid){
			proc += *(intptr_t*)((MenuItem*)menu.refat<1>(i))->node.obj.atpos();
			AppendMenu(hmenu, MF_STRING, proc.GetLength()-1, str.GetConst());
		}else{
			DestroyMenu(hmenu);
			proc.Clear();
			return false;
		}
	}
	return true;
}

TUserFunc(bool, MenuBar, int32_t procid, int32_t classid, Reference menu)
{
	ben->SetSSZFunc();
	int dw, dh;
	RECT rec;
	HMENU hmenu;
	PWCArray<intptr_t> tmp;
	if(!MakeMenu(hmenu, tmp, *ben, menu, classid, procid, true)) return false;
	DestroyMenu(g_hmenu);
	g_hmenu = hmenu;
	g_menucallback = tmp;
	SetMenu(g_hwnd, g_hmenu);
	DrawMenuBar(g_hwnd);
	GetClientRect(g_hwnd, &rec);
	dw = (g_rect.right - g_rect.left) - (rec.right - rec.left);
	dh = (g_rect.bottom - g_rect.top) - (rec.bottom - rec.top);
	if(dw != 0 || dh != 0){
		GetWindowRect(g_hwnd, &rec);
		MoveWindow(g_hwnd, rec.left, rec.top, rec.right-rec.left+dw, rec.bottom-rec.top+dh, TRUE);
	}
	return true;
}

